//+------------------------------------------------------------------+
//|                                          #MTF_TDI_D.mq4     |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 6

#property indicator_color1 Black
#property indicator_color2 Aqua
#property indicator_color3 Yellow
#property indicator_color4 Aqua
#property indicator_color5 Green
#property indicator_color6 Red

#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 1
#property indicator_width5 2
#property indicator_width6 2

#property indicator_level1 68.0
#property indicator_level2 63.0
#property indicator_level3 50.0
#property indicator_level4 37.0
#property indicator_level5 32.0
#property indicator_levelstyle  2
#property indicator_levelcolor  -1

//--
extern int RSI_Period = 13;         //8-25
extern int RSI_Price  = 0;           //0-6  (COHLMTW)
extern int Volatility_Band = 34;    //20-40
extern int RSI_Price_Line_Period = 2;      
extern int RSI_Price_Line_Type  = 0;      //0-3
extern int Trade_Signal_Line_Period = 5;   
extern int Trade_Signal_Line_Type = 0;   //0-3 (SMA EMA SMMA LWMA)  
extern int timeFrame = 0;
extern string note_timeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0currentTF";
extern string appliedPrice_   = "0C 1O 2H 3L 4Md 5Tp 6WghC, Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";
extern string MA_Type_        = "SMA0 EMA1 SMMA2 LWMA3";
string  IndicatorFileName; 

double RSIBuf[],UpZone[],MdZone[],DnZone[],MaBuf[],MbBuf[];
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0,RSIBuf);
   SetIndexBuffer(1,UpZone);
   SetIndexBuffer(2,MdZone);
   SetIndexBuffer(3,DnZone);
   SetIndexBuffer(4,MaBuf);
   SetIndexBuffer(5,MbBuf);

   SetIndexStyle(0,DRAW_NONE); 
   SetIndexStyle(1,DRAW_LINE); 
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   
   SetIndexLabel(0,NULL); 
   SetIndexLabel(1,"VolBand("+Volatility_Band+") High"); 
   SetIndexLabel(2,"MarketBaseLine(VolBand"+Volatility_Band+")"); 
   SetIndexLabel(3,"VolBand("+Volatility_Band+") Low"); 
   SetIndexLabel(4,"RSI("+RSI_Period+","+RSI_Price_Line_Period+") Price Line");
   SetIndexLabel(5,"Trade RSI_Signal_Line("+Trade_Signal_Line_Period+")");
  
           switch(timeFrame)
   {
      case 1: string TimeFrameStr = "M1";  break;
      case 5     :   TimeFrameStr = "M5";  break;
      case 15    :   TimeFrameStr = "M15"; break;
      case 30    :   TimeFrameStr = "M30"; break;
      case 60    :   TimeFrameStr = "H1";  break;
      case 240   :   TimeFrameStr = "H4";  break;
      case 1440  :   TimeFrameStr = "D1";  break;
      case 10080 :   TimeFrameStr = "W1";  break;
      case 43200 :   TimeFrameStr = "MN1"; break;
      default    :   TimeFrameStr = "TF0";
   }


   IndicatorShortName("TDI["+TimeFrameStr+"]");
     IndicatorFileName = WindowExpertName();

    if (timeFrame < Period()) timeFrame = Period();
 

   return(0);
  }


int start()
  {
   double MA,RSI[];
   ArrayResize(RSI,Volatility_Band);


  int counted_bars1=IndicatorCounted();
  int      limit1,i1;


   if(counted_bars1 < 0) return(-1);
   limit1 = Bars-counted_bars1;

   //
   //
   //    MTF mode operating
   //
   //

   if (timeFrame != Period())
      {
         limit1 = MathMax(limit1,timeFrame/Period());
         datetime TimeArray[];
            ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,timeFrame);
         
            //
            //
            //
            //
            //
         
            for(i1=0,int y=0; i1<limit1; i1++)
            {
               if(Time[i1]<TimeArray[y]) y++;
              RSIBuf[i1]   = iCustom(NULL,timeFrame,IndicatorFileName,
                                          RSI_Period,RSI_Price,Volatility_Band,
                                          RSI_Price_Line_Period,RSI_Price_Line_Type,
                                          Trade_Signal_Line_Period,Trade_Signal_Line_Type,0,y);
              UpZone[i1]   = iCustom(NULL,timeFrame,IndicatorFileName,
                                          RSI_Period,RSI_Price,Volatility_Band,
                                          RSI_Price_Line_Period,RSI_Price_Line_Type,
                                          Trade_Signal_Line_Period,Trade_Signal_Line_Type,1,y);
              MdZone[i1]   = iCustom(NULL,timeFrame,IndicatorFileName,
                                          RSI_Period,RSI_Price,Volatility_Band,
                                          RSI_Price_Line_Period,RSI_Price_Line_Type,
                                          Trade_Signal_Line_Period,Trade_Signal_Line_Type,2,y);
              DnZone[i1]   = iCustom(NULL,timeFrame,IndicatorFileName,
                                          RSI_Period,RSI_Price,Volatility_Band,
                                          RSI_Price_Line_Period,RSI_Price_Line_Type,
                                          Trade_Signal_Line_Period,Trade_Signal_Line_Type,3,y);
              MaBuf[i1]    = iCustom(NULL,timeFrame,IndicatorFileName,
                                          RSI_Period,RSI_Price,Volatility_Band,
                                          RSI_Price_Line_Period,RSI_Price_Line_Type,
                                          Trade_Signal_Line_Period,Trade_Signal_Line_Type,4,y);
              MbBuf[i1]    = iCustom(NULL,timeFrame,IndicatorFileName,
                                          RSI_Period,RSI_Price,Volatility_Band,
                                          RSI_Price_Line_Period,RSI_Price_Line_Type,
                                          Trade_Signal_Line_Period,Trade_Signal_Line_Type,5,y);

                }
         return(0);         
      }
      
   //
   //
   //
   //
   //
   int counted_bars=IndicatorCounted();
   int limit = Bars-counted_bars-1;
   for(int i=limit; i>=0; i--)
   {
      RSIBuf[i] = (iRSI(NULL,0,RSI_Period,RSI_Price,i)); 
      MA = 0; 
      for(int x=i; x<i+Volatility_Band;  x++) {
         RSI[x-i] = RSIBuf[x];
         MA += RSIBuf[x]/Volatility_Band;
      }
      UpZone[i] = (MA + (1.6185 * StDev(RSI,Volatility_Band)));
      DnZone[i] = (MA - (1.6185 * StDev(RSI,Volatility_Band)));  
      MdZone[i] = ((UpZone[i] + DnZone[i])/2);
    
  }

 
   for (i=limit-1;i>=0;i--)  
      {
       MaBuf[i] = (iMAOnArray(RSIBuf,0,RSI_Price_Line_Period,0,RSI_Price_Line_Type,i));
       MbBuf[i] = (iMAOnArray(RSIBuf,0,Trade_Signal_Line_Period,0,Trade_Signal_Line_Type,i));   
      } 
//----
   return(0);
  }
  
double StDev(double& Data[], int Per)
{return(MathSqrt(Variance(Data,Per)));
}
double Variance(double& Data[], int Per)
{double sum, ssum;
  for (int i=0; i<Per; i++)
  {sum += Data[i];
   ssum += MathPow(Data[i],2);
  }
  return((ssum*Per - sum*sum)/(Per*(Per-1)));
}
//+------------------------------------------------------------------+

